// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: internal/module/gitlab_access/rpc/rpc.proto

package rpc

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"google.golang.org/protobuf/types/known/anypb"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = anypb.Any{}
)

// Validate checks the field values on HeaderExtra with the rules defined in
// the proto definition for this message. If any rules are violated, an error
// is returned.
func (m *HeaderExtra) Validate() error {
	if m == nil {
		return nil
	}

	if utf8.RuneCountInString(m.GetModuleName()) < 1 {
		return HeaderExtraValidationError{
			field:  "ModuleName",
			reason: "value length must be at least 1 runes",
		}
	}

	return nil
}

// HeaderExtraValidationError is the validation error returned by
// HeaderExtra.Validate if the designated constraints aren't met.
type HeaderExtraValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e HeaderExtraValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e HeaderExtraValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e HeaderExtraValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e HeaderExtraValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e HeaderExtraValidationError) ErrorName() string { return "HeaderExtraValidationError" }

// Error satisfies the builtin error interface
func (e HeaderExtraValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sHeaderExtra.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = HeaderExtraValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = HeaderExtraValidationError{}
